"""Initial commit

Revision ID: 818a1251d4c2
Revises: 
Create Date: 2024-05-15 15:44:19.897013

"""

from typing import Sequence, Union
import sqlalchemy_utils

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects.postgresql import JSONB


# revision identifiers, used by Alembic.
revision: str = "818a1251d4c2"
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    conn = op.get_bind()
    if conn.dialect.name == "postgresql":
        json_type = JSONB
    else:
        json_type = sa.JSON()
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "metadata",
        sa.Column("data", json_type, nullable=True),
        sa.Column("id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("type", sa.String(length=255), nullable=False),
        sa.Column("name", sa.String(length=255), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "object",
        sa.Column("id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("type", sa.String(length=255), nullable=False),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "payload",
        sa.Column("data", sa.LargeBinary(length=4294967295), nullable=True),
        sa.Column("id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("type", sa.String(length=255), nullable=False),
        sa.Column("name", sa.String(length=255), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "tag",
        sa.Column("id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("name", sa.String(length=255), nullable=False),
        sa.Column("author", sa.String(length=255), nullable=True),
        sa.Column("type", sa.String(length=255), nullable=True),
        sa.Column("time", sa.DateTime(), nullable=True),
        sa.Column("comment", sa.String(length=255), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_tag_author"), "tag", ["author"], unique=False)
    op.create_index(op.f("ix_tag_name"), "tag", ["name"], unique=True)
    op.create_index(op.f("ix_tag_type"), "tag", ["type"], unique=False)
    op.create_table(
        "closure",
        sa.Column("ancestor_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("descendant_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("depth", sa.Integer(), nullable=False),
        sa.Column("view", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(["ancestor_id"], ["object.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["descendant_id"], ["object.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("ancestor_id", "descendant_id", "depth"),
    )
    op.create_table(
        "object_metadata",
        sa.Column("object_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("metadata_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.ForeignKeyConstraint(["metadata_id"], ["metadata.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["object_id"], ["object.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("object_id", "metadata_id"),
    )
    op.create_table(
        "object_payload",
        sa.Column("object_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("payload_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.ForeignKeyConstraint(["object_id"], ["object.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["payload_id"], ["payload.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("object_id", "payload_id"),
    )
    op.create_table(
        "tag_metadata",
        sa.Column("tag_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("metadata_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.ForeignKeyConstraint(["metadata_id"], ["metadata.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["tag_id"], ["tag.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("tag_id", "metadata_id"),
    )
    op.create_table(
        "tag_object",
        sa.Column("tag_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("object_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.ForeignKeyConstraint(["object_id"], ["object.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["tag_id"], ["tag.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("tag_id", "object_id"),
    )
    op.create_table(
        "tag_payload",
        sa.Column("tag_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.Column("payload_id", sqlalchemy_utils.types.uuid.UUIDType(binary=False), nullable=False),
        sa.ForeignKeyConstraint(["payload_id"], ["payload.id"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["tag_id"], ["tag.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("tag_id", "payload_id"),
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("tag_payload")
    op.drop_table("tag_object")
    op.drop_table("tag_metadata")
    op.drop_table("object_payload")
    op.drop_table("object_metadata")
    op.drop_table("closure")
    op.drop_index(op.f("ix_tag_type"), table_name="tag")
    op.drop_index(op.f("ix_tag_name"), table_name="tag")
    op.drop_index(op.f("ix_tag_author"), table_name="tag")
    op.drop_table("tag")
    op.drop_table("payload")
    op.drop_table("object")
    op.drop_table("metadata")
    # ### end Alembic commands ###
